 //#include <io.h>
#include "ADC.h"
 
#include <interrupt.h>
#include <sig-avr.h>
#include <progmem.h>

 
 //Initialize the A/D converter
 void ADC_init(void)
 {
 	outp((1<<ADEN) | (1<<ADPS2) | (ADPS1), ADCSR); //Initialize to use 8bit resolution for all channels
 }//ADC_init


 unsigned char ADC_getreading(int channel) //, int refvolt)
 {
	unsigned char IR_value;

 	//unsigned char temp_valueH;
 	
 	//if(refvolt == 1){
	//	outp((1<<REFS0)|(1<<REFS1)|(1<<ADLAR), ADMUX);	//use 4.95V as reference voltage
	//}
	//else{
		outp((1<<REFS0)|(1<<ADLAR), ADMUX);	//use 2.56V as reference voltage
	//}
	
	if(channel == 0){}
	else if(channel == 1){
		sbi(ADMUX, MUX0);
	}	
	else if(channel == 2){
		sbi(ADMUX, MUX1);
	}
	else if(channel == 3){
		sbi(ADMUX, MUX0);
		sbi(ADMUX, MUX1);
	}
	else if(channel == 4){
		sbi(ADMUX, MUX2);
	}
	else if(channel == 5){
		sbi(ADMUX, MUX2);
		sbi(ADMUX, MUX0);
	}
	else if (channel == 6){
		sbi(ADMUX, MUX2);
		sbi(ADMUX, MUX1);
	}
	else if (channel == 7){
		sbi(ADMUX, MUX2);
		sbi(ADMUX, MUX1);
		sbi(ADMUX, MUX0);	
	}
	
	sbi(ADCSR, ADSC);
	
	loop_until_bit_is_set(ADCSR, ADIF);		//wait till conversion is complete
	//temp_valueH = inp(ADCH); 
	IR_value = inp(ADCH);

	sbi(ADCSR, ADIF);
	
	return IR_value;
}//ADC_getreading
