#include "Camera.h"
#include "wait.h"
#include "UART.h"

#include <interrupt.h>
#include <sig-avr.h>
#include <progmem.h>




/* blinks the CMUcam tracking light */

void blink()
{
//	PRINT("RS\r\n");
//	wait(1000);
	
	PRINT("L1 1\r\n");
//	EOL();
	wait(1000);
	PRINT("L1 0\r\n");
	wait(1000);

  
}



/*
 * reset camera
 * enable poll mode
 * enable middle mass tracking mode
 * set auto-gain and exposure of 40
 * set color tracking parameters for orange ball
 * set auto mode for tracking light
 * set raw IO mode and ACK/NCK suppression
 */
void Camera_init(void)
{
  PRINT("RS"); //tx_command("RS");
  EOL();
  blink();
  PRINT("PM 1"); //tx_command("PM 1");
  EOL();
  blink();
//  PRINT("MM 1"); //tx_command("MM 1");
//  EOL();
  blink();
  PRINT("CR 19 32 16 140"); //tx_command("CR 19 32 16 40");
  EOL();
  wait(1000); //aCore_Sleep(2000);
}



unsigned char ParseString(void)
{
	unsigned char colon;
	unsigned char numdata;
	unsigned char Sdata;
	unsigned char rdata;
	unsigned char gdata;
	unsigned char bdata;

	PRINT("RM 3\r");
	wait(100);

    	PRINT("GM\r\n");
    	
    	colon = UART_ReceiveByte();
    	numdata = UART_ReceiveByte();
    	Sdata = UART_ReceiveByte();
    	rdata = UART_ReceiveByte();
    	gdata = UART_ReceiveByte();
    	bdata = UART_ReceiveByte();
//    	wait(100);
    	
    	blink();
    	return(rdata);
}
/*
    	blink();
    	
    	unsigned char BumpSensor;
    	BumpSensor = ADC_getreading(2);		
		while (BumpSensor > 50)
		{
			BumpSensor = ADC_getreading(2);
		
		}


    	PRINT("colon value = ");
    	UART_Printfu16(colon);
    	EOL();
      	
    	PRINT("255 value = ");
    	UART_Printfu16(numdata);
    	EOL();
 
    	PRINT("S value = ");
    	UART_Printfu16(Sdata);
    	EOL();
      	
     	PRINT("rdata value = ");
    	UART_Printfu16(rdata);
    	EOL();
    	
    	PRINT("gdata value = ");
    	UART_Printfu16(gdata);
    	EOL();
  
    	PRINT("bdata value = ");
    	UART_Printfu16(bdata);
    	EOL();
    
    	if(rdata > 223) 
    	{
    		PRINT("Rdata > 223");
    		EOL();
    	}
    	else
    	{
    		PRINT("Rdata <= 223");
    		EOL();
    	}
    	
    	blink();
   	return(Rdata);
}
    	*/
