#include <io.h>
#include <math.h>
#include <interrupt.h>
#include <sig-avr.h>
#include <progmem.h>

#include "motor.h"
#include "wait.h"
#include <stdlib.h>
#include <string.h>

#include "FindMascot.h"
#include "ADC.h"
#include "LED.h"
#include "UART.h"
#include "motor.h"
	

void FindMas(void)
{
	unsigned char IR_value;

//	motor_run(54, -969,	1000);  //fast straight
//	motor_run(50, -963,     5000);  //slow straight
//	motor_run(46, -960,	5000);  //slow backwards	
//	motor_run(47, -962,	5000);  //slow spin left				
//	motor_run(49, -961,	5000);  //slow spin right
					//left motor stops at 48
	motor_run(0, 0, 100);
	
	IR_value = ADC_getreading(0);
	
	
	
	while (IR_value < 24)
	{
		motor_run(49, -961, 100);
		IR_value = ADC_getreading(0);
		
		//IR_value = ADC_getreading(0);	
		//UART_Printfu16(IR_value);
		//EOL();

	}
	
	motor_run(49, -961, 200);
	
	IR_value = ADC_getreading(0);
	
	
	while (IR_value != 45)
	{
		//if (IR_value < 24)
		//{
		//	motor_run(46, -962,     100);
		//}
		//else
		if (IR_value < 45)
		{
			motor_run(49, -964,     100);
		}
		else
		{
			motor_run(46, -960,     100);
		}
		IR_value = ADC_getreading(0);
		
		//IR_value = ADC_getreading(0);	
		//UART_Printfu16(IR_value);
		//EOL();

		
	}
	
		IR_value = ADC_getreading(0);	
		//UART_Printfu16(IR_value);
		//EOL();
		wait(100);

	motor_run(0, 0, 100);

	
}

int FindWall(void)
{

	motor_run(38, -954, 	1000);	//backup
	motor_run(70, -950, 	500);	//spin
	motor_run(0, 0, 50);

	unsigned char IR_value;
	int count = 0;
	int answer;
	
	IR_value = ADC_getreading(0);

	while (IR_value < 85) //6inches
	{
		motor_run(54, -970,     20);
		count++;
		IR_value = ADC_getreading(0);
		
		PRINT("IR_value= ");
		UART_Printfu16(IR_value);	
		PRINT("  Count= ");				
		UART_Printfu16(count);
		EOL();		
	}
		motor_run(0,0,100);
		
	if (count > 149)
	{
		answer = 1;
	}
	else if (count > 91)
	{
		answer = 2;
	}
	else
	{	
		answer = 3;
	}
	UART_Printfu16(answer);
				
	return answer;
}