#include "music.h"
#include "wait.h"

#include <interrupt.h>
#include <sig-avr.h>
#include <progmem.h>



void Music_init(void)
{
	outp(0xff,DDRB);
	
//stop	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	sbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);	
	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

}	


void Play_OSU(void)
{
	outp(0xff,DDRB);

//stop	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	sbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);

//reset	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);

//start	
	cbi(PORTB,PB0);	//mode0
	cbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);
	
//play	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

/*
loop_until_bit_is_clear(PORTA, 4);	
	
wait(100);
//repeat
//stop	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	sbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);

//reset	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);

//start	
	cbi(PORTB,PB0);	//mode0
	cbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);
	
//play	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

*/
}



void Play_UF(void)
{
	outp(0xff,DDRB);

//stop	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	sbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);

//reset	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);
	
//set mode0	
	sbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);

//advance message	
	sbi(PORTB,PB0);	//mode0
	cbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);	

//end advance	
	sbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);

//reset	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);
//start	
	cbi(PORTB,PB0);	//mode0
	cbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);
	
//play	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
/*
//repeat

//stop	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	sbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);

//reset	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);
	
//set mode0	
	sbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);

//advance message	
	sbi(PORTB,PB0);	//mode0
	cbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);	

//end advance	
	sbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	

	wait(50);

//reset	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);
//start	
	cbi(PORTB,PB0);	//mode0
	cbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
	wait(50);
	
//play	
	cbi(PORTB,PB0);	//mode0
	sbi(PORTB,PB1);	//start/pause
	cbi(PORTB,PB2);	//stop/reset
	sbi(PORTB,PB3); //playbac/record
	cbi(PORTB,PB4);
	cbi(PORTB,PB5);
	cbi(PORTB,PB6);
	cbi(PORTB,PB7);	
	
*/	

}